﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;


namespace WpfTreeViewDragNDrop
{
    public partial class MainWindow : Window
    {
        private Boolean isRightTreeViewEmpty = true;

        public MainWindow()
        {
            InitializeComponent();
            radTreeViewLeft.ExpandAll();
            radTreeViewRight.ExpandAll();
        }

        private void radTreeView_PreviewDragEnded(object sender, Telerik.Windows.Controls.RadTreeViewDragEndedEventArgs e)
        {
            //cancel the DragEnded event in order to implement custom drag/drop logic
            e.Handled = true;

            // Adding an item to the empty right tree
            if (e.TargetDropItem == null)
            {
                //if the source of the PreviewDragEnded event is the left RadTreeView
                if (sender == radTreeViewLeft)
                {
                    return;
                }
                else
                {
                    MessageBoxResult result = MessageBox.Show("Allow drop ?", "Confirmation", MessageBoxButton.YesNo);
                    if (result != MessageBoxResult.No)
                    {
                        foreach (object item in e.DraggedItems)
                        {
                            RadTreeViewItem clonedItem = CopyItem(item as EditableHeaderedItemsControl);
                            ///adding items to the RadTreeView
                            radTreeViewRight.Items.Add(clonedItem);
                        }
                    }
                }
            }
            else
            {
                if (e.TargetDropItem.ParentTreeView != sender)
                {
                    //the object that raised the PreviewDragEnded event isn't the drop destination object
                    return;
                }
                //implement custom drop logic
                else
                {
                    MessageBoxResult result = MessageBox.Show("Allow drop ?", "Confirmation", MessageBoxButton.YesNo);
                    if (result == MessageBoxResult.Yes)
                    {
                        foreach (object item in e.DraggedItems)
                        {
                            RadTreeViewItem clonedItem = CopyItem(item as EditableHeaderedItemsControl);
                            switch (e.DropPosition)
                            {
                                case DropPosition.After:
                                    if (e.TargetDropItem.ParentItem != null)
                                    {
                                        e.TargetDropItem.ParentItem.Items.Insert(e.TargetDropItem.Index + 1, clonedItem);
                                    }
                                    else
                                        e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index + 1, clonedItem);
                                    break;
                                case DropPosition.Before:
                                    if (e.TargetDropItem.ParentItem != null)
                                    {
                                        e.TargetDropItem.ParentItem.Items.Insert(e.TargetDropItem.Index, clonedItem);
                                    }
                                    else
                                        e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index, clonedItem);
                                    break;
                                case DropPosition.Inside:
                                    e.TargetDropItem.Items.Add(clonedItem);
                                    break;
                                default:
                                    e.TargetDropItem.Items.Add(clonedItem);
                                    break;
                            }
                        }
                    }
                }
            }
        }

        public RadTreeViewItem CopyItem(EditableHeaderedItemsControl item)
        {
            RadTreeViewItem newItem = new RadTreeViewItem();
            newItem.Header = item.Header;
            return newItem;
        }
    }
}
